package org.library.app;

import org.javalite.activejdbc.Base;
import org.javalite.activejdbc.DBException;
import org.javalite.activejdbc.Model;

import java.util.List;

public class Book extends Model {
  private String name;

  public Book() {}

  public Book(String name) {
    set("name", name);
  }

  public String getName() {
    return getString("name");
  }

  public String getIsbn() {
    return getString("isbn");
  }

  public String getAuthor() {
    return getString("author");
  }

  public String getTakedAsStr() {
    String takedStr = null;
    Boolean taked = getBoolean("taked");

    if (taked) {
      takedStr = "да";
    } else {
      takedStr = "нет";
    }

    return takedStr;
  }

  public String getUserName() {
    Boolean taked = getBoolean("taked");
    User user = null;

    if (taked) {
      user = getTakedUser();
    }

    if (user == null) {
      return "";
    } else {
      return user.getName();
    }
  }

  public User getTakedUser() {
    User user = null;
    BooksUsers booksUsers = null;
    Base.open();

    List<BooksUsers> booksUsersList = BooksUsers.where("book_id = ? and wasreturn = ?", getInteger("id"), false);
    if (booksUsersList.size() > 0) {
      booksUsers = booksUsersList.get(0);
    }

    if (booksUsers == null) {
    } else {
      user = User.findById(booksUsers.getInteger("user_id"));
    }
    Base.close();
    return user;
  }

  public BooksUsers getTakedRelation() {
    BooksUsers booksUsers = null;
    Base.open();

    List<BooksUsers> booksUsersList = BooksUsers.where("book_id = ? and wasreturn = ?", getInteger("id"), false);
    if (booksUsersList.size() > 0) {
      booksUsers = booksUsersList.get(0);
    }

    Base.close();
    return booksUsers;
  }
}
