package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;

public class FormBookAddController {
  @FXML private Label labelFormTitle;

  @FXML private TextField bookName;
  @FXML private TextField bookISBN;
  @FXML private TextField bookAuthor;

  @FXML private Button btnFormSaveBook;
  @FXML private Button btnFormCancelBook;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        String name = bookName.getText();
        String isbn = bookISBN.getText();
        String author = bookAuthor.getText();

        appManager.addBookToDatabase(name, isbn, author);
        modalStage.close();
      }
    });

    btnFormCancelBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }
}
