package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;

public class FormBookEditController {
  @FXML private Label labelFormTitle;
  @FXML private TextField bookId;
  @FXML private TextField bookName;
  @FXML private TextField bookISBN;
  @FXML private TextField bookAuthor;
  @FXML private Button btnFormSaveBook;
  @FXML private Button btnFormCancelBook;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        int id = Integer.parseInt(bookId.getText());
        String name = bookName.getText();
        String isbn = bookISBN.getText();
        String author = bookAuthor.getText();

        appManager.updateBookToDatabase(id, name, isbn, author);
        modalStage.close();
      }
    });

    btnFormCancelBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }

  public void setBookValues(Book book) {
    bookId.setText(book.getString("id"));
    bookName.setText(book.getString("name"));
    bookISBN.setText(book.getString("isbn"));
    bookAuthor.setText(book.getString("author"));
  }
}
