package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import java.util.List;
import java.time.LocalDate;

public class FormBookGiveController {
  private ObservableList<User> usersList = FXCollections.observableArrayList();
  private List<User> usersFromDB;

  @FXML private Label labelFormTitle;
  @FXML private Label labelFormMessage;
  @FXML private Label bookName;

  @FXML private TextField bookId;
  @FXML private TextField howManyDays;
  @FXML private ComboBox comboUsersList;
  @FXML private DatePicker takeStartTime;

  @FXML private Button btnFormSaveBook;
  @FXML private Button btnFormCancelBook;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        Boolean haveUser = false;
        Boolean haveTakedAt = false;
        Boolean haveHowManyDays = false;

        int book_id = Integer.parseInt(bookId.getText());
        int howmanydays;
        try {
          howmanydays = Integer.parseInt(howManyDays.getText());
          haveHowManyDays = true;
        } catch (Exception err) {
          howmanydays = 0;
          labelFormMessage.setText("необходимо указать количество дней");
        }

        User user = ((User) comboUsersList.getSelectionModel().getSelectedItem());
        LocalDate taked_at = takeStartTime.getValue();

        if (user == null) {
          labelFormMessage.setText("необходимо выбрать читателя");
        } else {
          haveUser = true;
        }

        if (taked_at == null) {
          labelFormMessage.setText("необходимо выбрать дату начала чтения");
        } else {
          haveTakedAt = true;
        }

        if (howmanydays == 0) {
          labelFormMessage.setText("необходимо указать количество дней");
        }

        if (haveUser && haveTakedAt && haveHowManyDays) {
          labelFormMessage.setText("");
          appManager.addBookGiveToDatabase(book_id, howmanydays, user, taked_at);
          modalStage.close();
        }
      }
    });

    btnFormCancelBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }

  public void setBookValues(Book book) {
    bookId.setText(book.getString("id"));
    bookName.setText(book.getString("name"));
  }

  public void setUsersValues(List<User> users) {
    this.usersFromDB = users;
    for (User item : users) {
      usersList.add(item);
    }
    comboUsersList.setItems(usersList);
  }
}
