package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import java.util.List;
import java.time.LocalDate;

public class FormBookTakeController {
  @FXML private Label labelFormTitle;
  @FXML private Label labelFormMessage;
  @FXML private TextField booksUsersId;

  @FXML private Label bookName;
  @FXML private Label userName;
  @FXML private Label userNumber;
  @FXML private Label takeStartTime;
  @FXML private Label howManyDays;
  @FXML private Label takeStopTime;
  @FXML private Label takeTimeOut;

  @FXML private DatePicker returnTime;

  @FXML private Button btnFormSaveBook;
  @FXML private Button btnFormCancelBook;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        Boolean haveReturnAt = false;

        int usersBooksId = Integer.parseInt(booksUsersId.getText());

        LocalDate return_at = returnTime.getValue();

        if (return_at == null) {
          labelFormMessage.setText("необходимо выбрать дату возврата книги");
        } else {
          haveReturnAt = true;
        }

        if (haveReturnAt) {
          labelFormMessage.setText("");
          appManager.addBookTakeToDatabase(usersBooksId, return_at);
          modalStage.close();
        }
      }
    });

    btnFormCancelBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }

  public void setBooksUsersValues(Book book) {
    BooksUsers booksUsers = book.getTakedRelation();
    User user = book.getTakedUser();

    bookName.setText(book.getString("name"));
    booksUsersId.setText(booksUsers.getString("id"));
    userName.setText(user.getName());
    userNumber.setText(user.getString("number"));
    takeStartTime.setText(booksUsers.getTakedAtAsStr());
    howManyDays.setText(booksUsers.getString("howmanydays"));
    takeStopTime.setText(booksUsers.getTakedStopAtAsStr());
    takeTimeOut.setText(booksUsers.getTakedTimeOutAsStr());
  }
}
