package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;

public class FormUserAddController {
  @FXML private Label labelFormTitle;

  @FXML private TextField userSname;
  @FXML private TextField userFname;
  @FXML private TextField userMname;
  @FXML private TextField userNumber;

  @FXML private Button btnFormSaveBook;
  @FXML private Button btnFormCancelBook;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        String sname = userSname.getText();
        String fname = userFname.getText();
        String mname = userMname.getText();
        String number = userNumber.getText();

        appManager.addUserToDatabase(sname, fname, mname, number);
        modalStage.close();
      }
    });

    btnFormCancelBook.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }
}
