package org.library.app;

import javafx.event.*;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.stage.Stage;

public class FormUserEditController {
  @FXML private Label labelFormTitle;

  @FXML private TextField userId;
  @FXML private TextField userSname;
  @FXML private TextField userFname;
  @FXML private TextField userMname;
  @FXML private TextField userNumber;

  @FXML private Button btnFormSaveUser;
  @FXML private Button btnFormCancelUser;

  public void initialize() {
  }

  public void initController(final AppManager appManager, final Stage modalStage) {
    btnFormSaveUser.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        int id = Integer.parseInt(userId.getText());
        String sname = userSname.getText();
        String fname = userFname.getText();
        String mname = userMname.getText();
        String number = userNumber.getText();

        appManager.updateUserToDatabase(id, sname, fname, mname, number);
        modalStage.close();
      }
    });

    btnFormCancelUser.setOnAction(new EventHandler<ActionEvent>() {
      @Override
      public void handle(ActionEvent event) {
        modalStage.close();
      }
    });
  }

  public void setFormTitle(String title) {
    labelFormTitle.setText(title);
  }

  public void setUserValues(User user) {
    userId.setText(user.getString("id"));
    userSname.setText(user.getString("sname"));
    userFname.setText(user.getString("fname"));
    userMname.setText(user.getString("mname"));
    userNumber.setText(user.getString("number"));
  }
}
